#include <windows.h>
#include "export.h"

HINSTANCE hDLL;

GetTableFieldFn GetTableField;
nMoveFn nMove;
GameFn Game;
NextColourFn NextColour;	

EXPORT void __cdecl InitDLL(const char* exename)
{
	hDLL = LoadLibrary(exename);

	if (!hDLL)
		return;

	GetTableField = (GetTableFieldFn) GetProcAddress(hDLL, "GetTableField");
	nMove = (nMoveFn) GetProcAddress(hDLL, "nMove");
	Game = (GameFn) GetProcAddress(hDLL, "Game");
	NextColour = (NextColourFn) GetProcAddress(hDLL, "NextColour");
}

EXPORT void __cdecl ExitDLL()
{
	if (hDLL)
		FreeLibrary(hDLL);
}

EXPORT char* __cdecl DllName()
{
	return "Demo Dll";
}

EXPORT char* __cdecl AboutName()
{
	return "Lszl KISS";
}

EXPORT char* __cdecl AboutCountry()
{
	return "Hungary";
}

EXPORT char* __cdecl AboutEMail()
{
	return "geotop@mail.datanet.hu";
}

EXPORT void __cdecl RefreshBoard(long id)
{
	PlayerBase * player = (PlayerBase *)id;

	player->RefreshBoard();
}

EXPORT long __cdecl Move(long id)
{
	PlayerBase * player = (PlayerBase *)id;

	return player->Move();
}

EXPORT void __cdecl DeletePlayer(long id)
{
	PlayerBase * player = (PlayerBase *)id;

	delete player;
}

/////////////////////////////////////// player specific //////////////////////////////////////

#include "players.h"

char *pNeighbourPlayer = "Neighbour";
char *pRandomPlayer = "Random";
char *pEagerPlayer = "Eager";

EXPORT long __cdecl CreatePlayer(char* player_name)
{
	if (!_stricmp(player_name, pNeighbourPlayer))
		return (long)new NeighbourPlayer;
	
	if (!_stricmp(player_name, pRandomPlayer))
		return (long)new RandomPlayer;

	if (!_stricmp(player_name, pEagerPlayer))
		return (long)new EagerPlayer;

	return 0;
}

EXPORT char* __cdecl PlayerName(long iplayer)
{
	switch(iplayer)
	{
	case 1: return pNeighbourPlayer;
	case 2: return pRandomPlayer;
	case 3: return pEagerPlayer;
	}

	return 0;
}

Field Field::Dir[8] = 
{ 
	Field(0,1), 
	Field(1,1),
	Field(1,0),
	Field(1,-1),

	Field(0,-1), 
	Field(-1,-1),
	Field(-1,0),
	Field(-1,1),
};

