#include <string.h>
#include <stdlib.h>
#include <time.h>

#define EXPORT extern "C" __declspec(dllexport)

// table field coordinates (column and row) are stored in the two 
// consecutive shorts of a long

extern "C"
{
	typedef long (__cdecl *GetTableFieldFn)(long);  // returns 0, 1, 2 = none, black, white
	typedef long (__cdecl *nMoveFn)();
	typedef long (__cdecl *GameFn)(long);
	typedef long (__cdecl *NextColourFn)(); // to move
}

extern GetTableFieldFn GetTableField;
extern nMoveFn nMove;
extern GameFn Game;
extern NextColourFn NextColour;	
enum { black = 1, white = 2, };

EXPORT void __cdecl InitDLL(const char* exename);
EXPORT void __cdecl ExitDLL();
EXPORT char* __cdecl DllName();
EXPORT char* __cdecl AboutName();
EXPORT char* __cdecl AboutCountry();
EXPORT char* __cdecl AboutEMail();
EXPORT void __cdecl RefreshBoard(long id);
EXPORT char* __cdecl PlayerName(long iplayer);
EXPORT long __cdecl CreatePlayer(char * player_name);
EXPORT long __cdecl Move(long id);
EXPORT void __cdecl DeletePlayer(long id);

// Set level, 1-10, default = 4. 10 is the strongest.
// Not implemented in this demo program.
// EXPORT void __cdecl Level(long id, long n);    

// Functions for choice opening. Not implemented in this demo program.
//
// EXPORT void __cdecl OfferOpen1(long id, long* B1, long* W2);           // first two stones
// EXPORT void __cdecl OfferOpen2(long id, long* B3, long* W4, long* B5); // stones 3 to 5
// EXPORT void __cdecl ChOpening(long id);                                // choice color at 5th     


#define TABLE_SIZE 15

class PlayerBase
{
public:
	char table[TABLE_SIZE][TABLE_SIZE];
	
	PlayerBase() { InitTable(); }

	virtual long Move() = 0;
	virtual void RefreshBoard() = 0;
	virtual ~PlayerBase() {}

public:
	void InitTable() { memset(table, 0, sizeof(table)); }
};

class Field
{
public:
	short col;
	short row;

	static Field Dir[8];
public:
	Field() {}
	Field(short col_, short row_) : col(col_), row(row_) {}
	Field(long f) { *this = *(Field*)&f; col--; row--; }
	operator long () { Field f = *this; f.col++; f.row++; return *(long*)&f; }

	void Step(int direction, int offset)
	{
		col += Dir[direction].col * offset;
		row += Dir[direction].row * offset;
	}
};

inline int OppDir(int dir) { return dir < 4 ? dir+4 : dir-4; }
