
class RandomPlayer: public PlayerBase
{
public:
	virtual long Move();
	virtual void RefreshBoard() {}
};

class NeighbourPlayer: public PlayerBase
{
public:
	virtual long Move();
	virtual void RefreshBoard() {}
};

class EagerPlayer: public PlayerBase
{
public:
	char ourcolor;

	double val[2][9][15][15];
public:
	double incr;
	double decr;
	double up;
	double down;
	double impact;

	bool was_refresh;
public:
	EagerPlayer() { InitPlayer(); }

	void InitPlayer();
	
	void InitTable();
	void SetLastMove();

	void SetMove(const Field& f);

	void RecalcSum(int us, int dir, const Field& f, double val);

	bool IsValid(const Field& f) { return f.col >= 0 && f.col < TABLE_SIZE && f.row >= 0 && f.row < TABLE_SIZE; }
	bool IsValidMove(const Field& f) { return IsValid(f) && !table[f.col][f.row]; }

	char& Table(const Field& f) { return table[f.col][f.row]; }
	double& Val(int us, int dir, const Field& f) { return val[us][dir][f.col][f.row]; }
	double ValPower(double val);

public:
	virtual long Move();
	virtual void RefreshBoard();

};
