#include "export.h"
#include "players.h"

long GetField(short i, short j);
bool IsValidField(short col, short row) { return col >= 1 && col <= TABLE_SIZE && row >= 1 && row <= TABLE_SIZE; }
bool IsValidMove(short col, short row) { return IsValidField(col,row) && !GetField(col,row); }

class TableField
{
public:
	short col;
	short row;
public:
	TableField(short col_, short row_) : col(col_), row(row_) {}
	TableField(long i) { *this = *(TableField*)&i; }
	operator long () { return *(long*)(void*)this; }

	bool IsValid() { return IsValidField(col,row); }
	bool IsValidMove() { return IsValidField(col,row) && !GetField(col,row); }
};

inline long GetField(short i, short j) { return GetTableField(TableField(i,j)); }

long RandomPlayer::Move()
{
	srand(time(0));
	
	for(;;)
	{
		int i = rand() % TABLE_SIZE + 1;
		int j = rand() % TABLE_SIZE + 1;
		
		if (!GetField(i,j))
			return TableField(i,j);
	}

	return 0;
}

long NeighbourPlayer::Move()
{
	TableField last = nMove() ? Game(nMove()) : TableField(8,8);
	
	srand(time(0));
	
	for(int k = 0; k < 1000; k++)
	{
		short i = (rand() % 3) - 1;
		short j = (rand() % 3) - 1;

		short col = last.col + i;
		short row = last.row + j;

		if (IsValidMove(col,row))
			return TableField(col,row);
	}

	RandomPlayer& rp = (RandomPlayer&)*this;

	return rp.RandomPlayer::Move();
}
